#pragma once
// EXLApplication wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Excel {
  class EXLWorkbooks;
  class EXLWorkbook;

class EXLApplication : public VariantableDispatch {
public:
  EXLApplication() = default;
  EXLApplication(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  EXLApplication(const EXLApplication& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  EXLApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  LPDISPATCH get_ActiveCell();
  LPDISPATCH get_ActiveChart();
  LPDISPATCH get_ActiveDialog();
  LPDISPATCH get_ActiveMenuBar();
  CString get_ActivePrinter();
  void put_ActivePrinter(LPCTSTR newValue);
  LPDISPATCH get_ActiveSheet();
  LPDISPATCH get_ActiveWindow();
  LPDISPATCH get_ActiveWorkbook();
  LPDISPATCH get_AddIns();
  LPDISPATCH get_Assistant();
  void Calculate();
  LPDISPATCH get_Cells();
  LPDISPATCH get_Charts();
  LPDISPATCH get_Columns();
  LPDISPATCH get_CommandBars();
  long get_DDEAppReturnCode();
  void DDEExecute(long Channel, LPCTSTR String);
  long DDEInitiate(LPCTSTR App, LPCTSTR Topic);
  void DDEPoke(long Channel, VARIANT Item, VARIANT Data);
  VARIANT DDERequest(long Channel, LPCTSTR Item);
  void DDETerminate(long Channel);
  LPDISPATCH get_DialogSheets();
  VARIANT Evaluate(VARIANT Name);
  VARIANT _Evaluate(VARIANT Name);
  VARIANT ExecuteExcel4Macro(LPCTSTR String);
  LPDISPATCH Intersect(LPDISPATCH Arg1, LPDISPATCH Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30);
  LPDISPATCH get_MenuBars();
  LPDISPATCH get_Modules();
  LPDISPATCH get_Names();
  LPDISPATCH get_Range(VARIANT Cell1, VARIANT Cell2);
  LPDISPATCH get_Rows();
  VARIANT Run(VARIANT Macro, VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30);
  VARIANT _Run2(VARIANT Macro, VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30);
  LPDISPATCH get_Selection();
  void SendKeys(VARIANT Keys, VARIANT Wait);
  LPDISPATCH get_Sheets();
  LPDISPATCH get_ShortcutMenus(long IndexType);
  LPDISPATCH get_ThisWorkbook();
  LPDISPATCH get_Toolbars();
  LPDISPATCH Union(LPDISPATCH Arg1, LPDISPATCH Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30);
  LPDISPATCH get_Windows();
  EXLWorkbooks get_Workbooks();
  LPDISPATCH get_WorksheetFunction();
  LPDISPATCH get_Worksheets();
  LPDISPATCH get_Excel4IntlMacroSheets();
  LPDISPATCH get_Excel4MacroSheets();
  void ActivateMicrosoftApp(long IndexType);
  void AddChartAutoFormat(VARIANT Chart, LPCTSTR Name, VARIANT Description);
  void AddCustomList(VARIANT ListArray, VARIANT ByRow);
  BOOL get_AlertBeforeOverwriting();
  void put_AlertBeforeOverwriting(BOOL newValue);
  CString get_AltStartupPath();
  void put_AltStartupPath(LPCTSTR newValue);
  BOOL get_AskToUpdateLinks();
  void put_AskToUpdateLinks(BOOL newValue);
  BOOL get_EnableAnimations();
  void put_EnableAnimations(BOOL newValue);
  LPDISPATCH get_AutoCorrect();
  long get_Build();
  BOOL get_CalculateBeforeSave();
  void put_CalculateBeforeSave(BOOL newValue);
  long get_Calculation();
  void put_Calculation(long newValue);
  VARIANT get_Caller(VARIANT IndexType);
  BOOL get_CanPlaySounds();
  BOOL get_CanRecordSounds();
  CString get_Caption();
  void put_Caption(LPCTSTR newValue);
  BOOL get_CellDragAndDrop();
  void put_CellDragAndDrop(BOOL newValue);
  double CentimetersToPoints(double Centimeters);
  BOOL CheckSpelling(LPCTSTR Word, VARIANT CustomDictionary, VARIANT IgnoreUppercase);
  VARIANT get_ClipboardFormats(VARIANT IndexType);
  BOOL get_DisplayClipboardWindow();
  void put_DisplayClipboardWindow(BOOL newValue);
  BOOL get_ColorButtons();
  void put_ColorButtons(BOOL newValue);
  long get_CommandUnderlines();
  void put_CommandUnderlines(long newValue);
  BOOL get_ConstrainNumeric();
  void put_ConstrainNumeric(BOOL newValue);
  VARIANT ConvertFormula(VARIANT Formula, long FromReferenceStyle, VARIANT ToReferenceStyle, VARIANT ToAbsolute, VARIANT RelativeTo);
  BOOL get_CopyObjectsWithCells();
  void put_CopyObjectsWithCells(BOOL newValue);
  long get_Cursor();
  void put_Cursor(long newValue);
  long get_CustomListCount();
  long get_CutCopyMode();
  void put_CutCopyMode(long newValue);
  long get_DataEntryMode();
  void put_DataEntryMode(long newValue);
  VARIANT Dummy1(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4);
  VARIANT Dummy2(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8);
  VARIANT Dummy3();
  VARIANT Dummy4(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15);
  VARIANT Dummy5(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13);
  VARIANT Dummy6();
  VARIANT Dummy7();
  VARIANT Dummy8(VARIANT Arg1);
  VARIANT Dummy9();
  BOOL Dummy10(VARIANT arg);
  void Dummy11();
  CString get__Default();
  CString get_DefaultFilePath();
  void put_DefaultFilePath(LPCTSTR newValue);
  void DeleteChartAutoFormat(LPCTSTR Name);
  void DeleteCustomList(long ListNum);
  LPDISPATCH get_Dialogs();
  BOOL get_DisplayAlerts();
  void put_DisplayAlerts(BOOL newValue);
  BOOL get_DisplayFormulaBar();
  void put_DisplayFormulaBar(BOOL newValue);
  BOOL get_DisplayFullScreen();
  void put_DisplayFullScreen(BOOL newValue);
  BOOL get_DisplayNoteIndicator();
  void put_DisplayNoteIndicator(BOOL newValue);
  long get_DisplayCommentIndicator();
  void put_DisplayCommentIndicator(long newValue);
  BOOL get_DisplayExcel4Menus();
  void put_DisplayExcel4Menus(BOOL newValue);
  BOOL get_DisplayRecentFiles();
  void put_DisplayRecentFiles(BOOL newValue);
  BOOL get_DisplayScrollBars();
  void put_DisplayScrollBars(BOOL newValue);
  BOOL get_DisplayStatusBar();
  void put_DisplayStatusBar(BOOL newValue);
  void DoubleClick();
  BOOL get_EditDirectlyInCell();
  void put_EditDirectlyInCell(BOOL newValue);
  BOOL get_EnableAutoComplete();
  void put_EnableAutoComplete(BOOL newValue);
  long get_EnableCancelKey();
  void put_EnableCancelKey(long newValue);
  BOOL get_EnableSound();
  void put_EnableSound(BOOL newValue);
  BOOL get_EnableTipWizard();
  void put_EnableTipWizard(BOOL newValue);
  VARIANT get_FileConverters(VARIANT Index1, VARIANT Index2);
  LPDISPATCH get_FileSearch();
  LPDISPATCH get_FileFind();
  void _FindFile();
  BOOL get_FixedDecimal();
  void put_FixedDecimal(BOOL newValue);
  long get_FixedDecimalPlaces();
  void put_FixedDecimalPlaces(long newValue);
  VARIANT GetCustomListContents(long ListNum);
  long GetCustomListNum(VARIANT ListArray);
  VARIANT GetOpenFilename(VARIANT FileFilter, VARIANT FilterIndex, VARIANT Title, VARIANT ButtonText, VARIANT MultiSelect);
  VARIANT GetSaveAsFilename(VARIANT InitialFilename, VARIANT FileFilter, VARIANT FilterIndex, VARIANT Title, VARIANT ButtonText);
  void Goto(VARIANT Reference, VARIANT Scroll);
  double get_Height();
  void put_Height(double newValue);
  void Help(VARIANT HelpFile, VARIANT HelpContextID);
  BOOL get_IgnoreRemoteRequests();
  void put_IgnoreRemoteRequests(BOOL newValue);
  double InchesToPoints(double Inches);
  VARIANT InputBox(LPCTSTR Prompt, VARIANT Title, VARIANT Default, VARIANT Left, VARIANT Top, VARIANT HelpFile, VARIANT HelpContextID, VARIANT Type);
  BOOL get_Interactive();
  void put_Interactive(BOOL newValue);
  VARIANT get_International(VARIANT IndexType);
  BOOL get_Iteration();
  void put_Iteration(BOOL newValue);
  BOOL get_LargeButtons();
  void put_LargeButtons(BOOL newValue);
  double get_Left();
  void put_Left(double newValue);
  CString get_LibraryPath();
  void _MacroOptions(VARIANT Macro, VARIANT Description, VARIANT HasMenu, VARIANT MenuText, VARIANT HasShortcutKey, VARIANT ShortcutKey, VARIANT Category, VARIANT StatusBar, VARIANT HelpContextID, VARIANT HelpFile);
  void MailLogoff();
  void MailLogon(VARIANT Name, VARIANT Password, VARIANT DownloadNewMail);
  VARIANT get_MailSession();
  long get_MailSystem();
  BOOL get_MathCoprocessorAvailable();
  double get_MaxChange();
  void put_MaxChange(double newValue);
  long get_MaxIterations();
  void put_MaxIterations(long newValue);
  long get_MemoryFree();
  long get_MemoryTotal();
  long get_MemoryUsed();
  BOOL get_MouseAvailable();
  BOOL get_MoveAfterReturn();
  void put_MoveAfterReturn(BOOL newValue);
  long get_MoveAfterReturnDirection();
  void put_MoveAfterReturnDirection(long newValue);
  LPDISPATCH get_RecentFiles();
  CString get_Name();
  LPDISPATCH NextLetter();
  CString get_NetworkTemplatesPath();
  LPDISPATCH get_ODBCErrors();
  long get_ODBCTimeout();
  void put_ODBCTimeout(long newValue);
  CString get_OnCalculate();
  void put_OnCalculate(LPCTSTR newValue);
  CString get_OnData();
  void put_OnData(LPCTSTR newValue);
  CString get_OnDoubleClick();
  void put_OnDoubleClick(LPCTSTR newValue);
  CString get_OnEntry();
  void put_OnEntry(LPCTSTR newValue);
  void OnKey(LPCTSTR Key, VARIANT Procedure);
  void OnRepeat(LPCTSTR Text, LPCTSTR Procedure);
  CString get_OnSheetActivate();
  void put_OnSheetActivate(LPCTSTR newValue);
  CString get_OnSheetDeactivate();
  void put_OnSheetDeactivate(LPCTSTR newValue);
  void OnTime(VARIANT EarliestTime, LPCTSTR Procedure, VARIANT LatestTime, VARIANT Schedule);
  void OnUndo(LPCTSTR Text, LPCTSTR Procedure);
  CString get_OnWindow();
  void put_OnWindow(LPCTSTR newValue);
  CString get_OperatingSystem();
  CString get_OrganizationName();
  CString get_Path();
  CString get_PathSeparator();
  VARIANT get_PreviousSelections(VARIANT IndexType);
  BOOL get_PivotTableSelection();
  void put_PivotTableSelection(BOOL newValue);
  BOOL get_PromptForSummaryInfo();
  void put_PromptForSummaryInfo(BOOL newValue);
  void Quit();
  void RecordMacro(VARIANT BasicCode, VARIANT XlmCode);
  BOOL get_RecordRelative();
  long get_ReferenceStyle();
  void put_ReferenceStyle(long newValue);
  VARIANT get_RegisteredFunctions(VARIANT Index1, VARIANT Index2);
  BOOL RegisterXLL(LPCTSTR Filename);
  void Repeat();
  void ResetTipWizard();
  BOOL get_RollZoom();
  void put_RollZoom(BOOL newValue);
  void Save(VARIANT Filename);
  void SaveWorkspace(VARIANT Filename);
  BOOL get_ScreenUpdating();
  void put_ScreenUpdating(BOOL newValue);
  void SetDefaultChart(VARIANT FormatName, VARIANT Gallery);
  long get_SheetsInNewWorkbook();
  void put_SheetsInNewWorkbook(long newValue);
  BOOL get_ShowChartTipNames();
  void put_ShowChartTipNames(BOOL newValue);
  BOOL get_ShowChartTipValues();
  void put_ShowChartTipValues(BOOL newValue);
  CString get_StandardFont();
  void put_StandardFont(LPCTSTR newValue);
  double get_StandardFontSize();
  void put_StandardFontSize(double newValue);
  CString get_StartupPath();
  VARIANT get_StatusBar();
  void put_StatusBar(VARIANT newValue);
  CString get_TemplatesPath();
  BOOL get_ShowToolTips();
  void put_ShowToolTips(BOOL newValue);
  double get_Top();
  void put_Top(double newValue);
  long get_DefaultSaveFormat();
  void put_DefaultSaveFormat(long newValue);
  CString get_TransitionMenuKey();
  void put_TransitionMenuKey(LPCTSTR newValue);
  long get_TransitionMenuKeyAction();
  void put_TransitionMenuKeyAction(long newValue);
  BOOL get_TransitionNavigKeys();
  void put_TransitionNavigKeys(BOOL newValue);
  void Undo();
  double get_UsableHeight();
  double get_UsableWidth();
  BOOL get_UserControl();
  void put_UserControl(BOOL newValue);
  CString get_UserName();
  void put_UserName(LPCTSTR newValue);
  CString get_Value();
  LPDISPATCH get_VBE();
  CString get_Version();
  BOOL get_Visible();
  void put_Visible(BOOL newValue);
  void Volatile(VARIANT Volatile);
  void _Wait(VARIANT Time);
  double get_Width();
  void put_Width(double newValue);
  BOOL get_WindowsForPens();
  long get_WindowState();
  void put_WindowState(long newValue);
  long get_UILanguage();
  void put_UILanguage(long newValue);
  long get_DefaultSheetDirection();
  void put_DefaultSheetDirection(long newValue);
  long get_CursorMovement();
  void put_CursorMovement(long newValue);
  BOOL get_ControlCharacters();
  void put_ControlCharacters(BOOL newValue);
  VARIANT _WSFunction(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30);
  BOOL get_EnableEvents();
  void put_EnableEvents(BOOL newValue);
  BOOL get_DisplayInfoWindow();
  void put_DisplayInfoWindow(BOOL newValue);
  BOOL Wait(VARIANT Time);
  BOOL get_ExtendList();
  void put_ExtendList(BOOL newValue);
  LPDISPATCH get_OLEDBErrors();
  CString GetPhonetic(VARIANT Text);
  LPDISPATCH get_COMAddIns();
  LPDISPATCH get_DefaultWebOptions();
  CString get_ProductCode();
  CString get_UserLibraryPath();
  BOOL get_AutoPercentEntry();
  void put_AutoPercentEntry(BOOL newValue);
  LPDISPATCH get_LanguageSettings();
  LPDISPATCH get_Dummy101();
  void Dummy12(LPDISPATCH p1, LPDISPATCH p2);
  LPDISPATCH get_AnswerWizard();
  void CalculateFull();
  BOOL FindFile();
  long get_CalculationVersion();
  BOOL get_ShowWindowsInTaskbar();
  void put_ShowWindowsInTaskbar(BOOL newValue);
  long get_FeatureInstall();
  void put_FeatureInstall(long newValue);
  BOOL get_Ready();
  VARIANT Dummy13(VARIANT Arg1, VARIANT Arg2, VARIANT Arg3, VARIANT Arg4, VARIANT Arg5, VARIANT Arg6, VARIANT Arg7, VARIANT Arg8, VARIANT Arg9, VARIANT Arg10, VARIANT Arg11, VARIANT Arg12, VARIANT Arg13, VARIANT Arg14, VARIANT Arg15, VARIANT Arg16, VARIANT Arg17, VARIANT Arg18, VARIANT Arg19, VARIANT Arg20, VARIANT Arg21, VARIANT Arg22, VARIANT Arg23, VARIANT Arg24, VARIANT Arg25, VARIANT Arg26, VARIANT Arg27, VARIANT Arg28, VARIANT Arg29, VARIANT Arg30);
  LPDISPATCH get_FindFormat();
  void putref_FindFormat(LPDISPATCH newValue);
  LPDISPATCH get_ReplaceFormat();
  void putref_ReplaceFormat(LPDISPATCH newValue);
  LPDISPATCH get_UsedObjects();
  long get_CalculationState();
  long get_CalculationInterruptKey();
  void put_CalculationInterruptKey(long newValue);
  LPDISPATCH get_Watches();
  BOOL get_DisplayFunctionToolTips();
  void put_DisplayFunctionToolTips(BOOL newValue);
  long get_AutomationSecurity();
  void put_AutomationSecurity(long newValue);
  LPDISPATCH get_FileDialog(long fileDialogType);
  void Dummy14();
  void CalculateFullRebuild();
  BOOL get_DisplayPasteOptions();
  void put_DisplayPasteOptions(BOOL newValue);
  BOOL get_DisplayInsertOptions();
  void put_DisplayInsertOptions(BOOL newValue);
  BOOL get_GenerateGetPivotData();
  void put_GenerateGetPivotData(BOOL newValue);
  LPDISPATCH get_AutoRecover();
  long get_Hwnd();
  long get_Hinstance();
  void CheckAbort(VARIANT KeepAbort);
  LPDISPATCH get_ErrorCheckingOptions();
  BOOL get_AutoFormatAsYouTypeReplaceHyperlinks();
  void put_AutoFormatAsYouTypeReplaceHyperlinks(BOOL newValue);
  LPDISPATCH get_SmartTagRecognizers();
  LPDISPATCH get_NewWorkbook();
  LPDISPATCH get_SpellingOptions();
  LPDISPATCH get_Speech();
  BOOL get_MapPaperSize();
  void put_MapPaperSize(BOOL newValue);
  BOOL get_ShowStartupDialog();
  void put_ShowStartupDialog(BOOL newValue);
  CString get_DecimalSeparator();
  void put_DecimalSeparator(LPCTSTR newValue);
  CString get_ThousandsSeparator();
  void put_ThousandsSeparator(LPCTSTR newValue);
  BOOL get_UseSystemSeparators();
  void put_UseSystemSeparators(BOOL newValue);
  LPDISPATCH get_ThisCell();
  LPDISPATCH get_RTD();
  BOOL get_DisplayDocumentActionTaskPane();
  void put_DisplayDocumentActionTaskPane(BOOL newValue);
  void DisplayXMLSourcePane(VARIANT XmlMap);
  BOOL get_ArbitraryXMLSupportAvailable();
  VARIANT Support(LPDISPATCH Object, long ID, VARIANT arg);
  VARIANT Dummy20(long grfCompareFunctions);
  long get_MeasurementUnit();
  void put_MeasurementUnit(long newValue);
  BOOL get_ShowSelectionFloaties();
  void put_ShowSelectionFloaties(BOOL newValue);
  BOOL get_ShowMenuFloaties();
  void put_ShowMenuFloaties(BOOL newValue);
  BOOL get_ShowDevTools();
  void put_ShowDevTools(BOOL newValue);
  BOOL get_EnableLivePreview();
  void put_EnableLivePreview(BOOL newValue);
  BOOL get_DisplayDocumentInformationPanel();
  void put_DisplayDocumentInformationPanel(BOOL newValue);
  BOOL get_AlwaysUseClearType();
  void put_AlwaysUseClearType(BOOL newValue);
  BOOL get_WarnOnFunctionNameConflict();
  void put_WarnOnFunctionNameConflict(BOOL newValue);
  long get_FormulaBarHeight();
  void put_FormulaBarHeight(long newValue);
  BOOL get_DisplayFormulaAutoComplete();
  void put_DisplayFormulaAutoComplete(BOOL newValue);
  long get_GenerateTableRefs();
  void put_GenerateTableRefs(long newValue);
  LPDISPATCH get_Assistance();
  void CalculateUntilAsyncQueriesDone();
  BOOL get_EnableLargeOperationAlert();
  void put_EnableLargeOperationAlert(BOOL newValue);
  long get_LargeOperationCellThousandCount();
  void put_LargeOperationCellThousandCount(long newValue);
  BOOL get_DeferAsyncQueries();
  void put_DeferAsyncQueries(BOOL newValue);
  LPDISPATCH get_MultiThreadedCalculation();
  long SharePointVersion(LPCTSTR bstrUrl);
  long get_ActiveEncryptionSession();
  BOOL get_HighQualityModeForGraphics();
  void put_HighQualityModeForGraphics(BOOL newValue);
  LPDISPATCH get_FileExportConverters();
  LPDISPATCH get_SmartArtLayouts();
  LPDISPATCH get_SmartArtQuickStyles();
  LPDISPATCH get_SmartArtColors();
  LPDISPATCH get_AddIns2();
  BOOL get_PrintCommunication();
  void put_PrintCommunication(BOOL newValue);
  void MacroOptions(VARIANT Macro, VARIANT Description, VARIANT HasMenu, VARIANT MenuText, VARIANT HasShortcutKey, VARIANT ShortcutKey, VARIANT Category, VARIANT StatusBar, VARIANT HelpContextID, VARIANT HelpFile, VARIANT ArgumentDescriptions);
  BOOL get_UseClusterConnector();
  void put_UseClusterConnector(BOOL newValue);
  CString get_ClusterConnector();
  void put_ClusterConnector(LPCTSTR newValue);
  BOOL get_Quitting();
  BOOL get_Dummy22();
  void put_Dummy22(BOOL newValue);
  BOOL get_Dummy23();
  void put_Dummy23(BOOL newValue);
  LPDISPATCH get_ProtectedViewWindows();
  LPDISPATCH get_ActiveProtectedViewWindow();
  BOOL get_IsSandboxed();
  BOOL get_SaveISO8601Dates();
  void put_SaveISO8601Dates(BOOL newValue);
  VARIANT get_HinstancePtr();
  long get_FileValidation();
  void put_FileValidation(long newValue);
  long get_FileValidationPivot();
  void put_FileValidationPivot(long newValue);
  BOOL get_ShowQuickAnalysis();
  void put_ShowQuickAnalysis(BOOL newValue);
  LPDISPATCH get_QuickAnalysis();
  BOOL get_FlashFill();
  void put_FlashFill(BOOL newValue);
  BOOL get_EnableMacroAnimations();
  void put_EnableMacroAnimations(BOOL newValue);
  BOOL get_ChartDataPointTrack();
  void put_ChartDataPointTrack(BOOL newValue);
  BOOL get_FlashFillMode();
  void put_FlashFillMode(BOOL newValue);
  BOOL get_MergeInstances();
  void put_MergeInstances(BOOL newValue);
  BOOL get_EnableCheckFileExtensions();
  void put_EnableCheckFileExtensions(BOOL newValue);
};

} // namespace MSO::Excel
