#pragma once
// EXLWorkbooks wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Excel {
  class EXLWorkbook;

class EXLWorkbooks :
  public VariantableDispatch,
  public MSCollection<EXLWorkbooks, EXLWorkbook> {
public:
  EXLWorkbooks() = default;
  EXLWorkbooks(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  EXLWorkbooks(const EXLWorkbooks& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  long get_Count();
  LPDISPATCH get_Item(VARIANT IndexType);
  LPUNKNOWN get_NewEnum();
  LPDISPATCH get__Default(VARIANT IndexType);

  void Close();

  void CheckOut(LPCTSTR Filename);
  BOOL CanCheckOut(LPCTSTR Filename);

  EXLWorkbook Add(VARIANT Template);

  EXLWorkbook _Open(LPCTSTR Filename, VARIANT UpdateLinks, VARIANT ReadOnly, VARIANT Format,
    VARIANT Password, VARIANT WriteResPassword, VARIANT IgnoreReadOnlyRecommended, VARIANT Origin,
    VARIANT Delimiter, VARIANT Editable, VARIANT Notify, VARIANT Converter, VARIANT AddToMru);

  EXLWorkbook Open(LPCTSTR Filename, VARIANT UpdateLinks, VARIANT ReadOnly, VARIANT Format,
    VARIANT Password, VARIANT WriteResPassword, VARIANT IgnoreReadOnlyRecommended, VARIANT Origin,
    VARIANT Delimiter, VARIANT Editable, VARIANT Notify, VARIANT Converter, VARIANT AddToMru, VARIANT Local, VARIANT CorruptLoad);

  void __OpenText(LPCTSTR Filename, VARIANT Origin, VARIANT StartRow, VARIANT DataType,
    long TextQualifier, VARIANT ConsecutiveDelimiter, VARIANT Tab, VARIANT Semicolon, VARIANT Comma,
    VARIANT Space, VARIANT Other, VARIANT OtherChar, VARIANT FieldInfo, VARIANT TextVisualLayout);

  void _OpenText(LPCTSTR Filename, VARIANT Origin, VARIANT StartRow, VARIANT DataType, long TextQualifier,
    VARIANT ConsecutiveDelimiter, VARIANT Tab, VARIANT Semicolon, VARIANT Comma, VARIANT Space, VARIANT Other,
    VARIANT OtherChar, VARIANT FieldInfo, VARIANT TextVisualLayout, VARIANT DecimalSeparator, VARIANT ThousandsSeparator);

  void OpenText(LPCTSTR Filename, VARIANT Origin, VARIANT StartRow, VARIANT DataType, long TextQualifier,
    VARIANT ConsecutiveDelimiter, VARIANT Tab, VARIANT Semicolon, VARIANT Comma, VARIANT Space, VARIANT Other,
    VARIANT OtherChar, VARIANT FieldInfo, VARIANT TextVisualLayout, VARIANT DecimalSeparator, VARIANT ThousandsSeparator,
    VARIANT TrailingMinusNumbers, VARIANT Local);

  LPDISPATCH OpenDatabase(LPCTSTR Filename, VARIANT CommandText, VARIANT CommandType, VARIANT BackgroundQuery, VARIANT ImportDataAs);
  LPDISPATCH _OpenXML(LPCTSTR Filename, VARIANT Stylesheets);
  LPDISPATCH OpenXML(LPCTSTR Filename, VARIANT Stylesheets, VARIANT LoadOption);
};

} // namespace MSO::Excel
