#pragma once
// EXLWorksheet wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Excel {
  class EXLRange;

class EXLWorksheet : public VariantableDispatch {
public:
  EXLWorksheet() = default;
  EXLWorksheet(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  EXLWorksheet(const EXLWorksheet& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  EXLRange get_Cells();
  EXLRange get_Columns();
  EXLRange get_Rows();
  EXLRange get_UsedRange();

  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  void Activate();
  void Copy(VARIANT Before, VARIANT After);
  void Delete();
  CString get_CodeName();
  CString get__CodeName();
  void put__CodeName(LPCTSTR newValue);
  long get_Index();
  void Move(VARIANT Before, VARIANT After);
  CString get_Name();
  void put_Name(LPCTSTR newValue);
  LPDISPATCH get_Next();
  CString get_OnDoubleClick();
  void put_OnDoubleClick(LPCTSTR newValue);
  CString get_OnSheetActivate();
  void put_OnSheetActivate(LPCTSTR newValue);
  CString get_OnSheetDeactivate();
  void put_OnSheetDeactivate(LPCTSTR newValue);
  LPDISPATCH get_PageSetup();
  LPDISPATCH get_Previous();
  void __PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate);
  void PrintPreview(VARIANT EnableChanges);
  void _Protect(VARIANT Password, VARIANT DrawingObjects, VARIANT Contents, VARIANT Scenarios, VARIANT UserInterfaceOnly);
  BOOL get_ProtectContents();
  BOOL get_ProtectDrawingObjects();
  BOOL get_ProtectionMode();
  BOOL get_ProtectScenarios();
  void _SaveAs(LPCTSTR Filename, VARIANT FileFormat, VARIANT Password, VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, VARIANT AddToMru, VARIANT TextCodepage, VARIANT TextVisualLayout);
  void Select(VARIANT Replace);
  void Unprotect(VARIANT Password);
  long get_Visible();
  void put_Visible(long newValue);
  LPDISPATCH get_Shapes();
  BOOL get_TransitionExpEval();
  void put_TransitionExpEval(BOOL newValue);
  LPDISPATCH Arcs(VARIANT IndexType);
  BOOL get_AutoFilterMode();
  void put_AutoFilterMode(BOOL newValue);
  void SetBackgroundPicture(LPCTSTR Filename);
  LPDISPATCH Buttons(VARIANT IndexType);
  void Calculate();
  BOOL get_EnableCalculation();
  void put_EnableCalculation(BOOL newValue);
  LPDISPATCH ChartObjects(VARIANT IndexType);
  LPDISPATCH CheckBoxes(VARIANT IndexType);
  void CheckSpelling(VARIANT CustomDictionary, VARIANT IgnoreUppercase, VARIANT AlwaysSuggest, VARIANT SpellLang);
  LPDISPATCH get_CircularReference();
  void ClearArrows();
  long get_ConsolidationFunction();
  VARIANT get_ConsolidationOptions();
  VARIANT get_ConsolidationSources();
  BOOL get_DisplayAutomaticPageBreaks();
  void put_DisplayAutomaticPageBreaks(BOOL newValue);
  LPDISPATCH Drawings(VARIANT IndexType);
  LPDISPATCH DrawingObjects(VARIANT IndexType);
  LPDISPATCH DropDowns(VARIANT IndexType);
  BOOL get_EnableAutoFilter();
  void put_EnableAutoFilter(BOOL newValue);
  long get_EnableSelection();
  void put_EnableSelection(long newValue);
  BOOL get_EnableOutlining();
  void put_EnableOutlining(BOOL newValue);
  BOOL get_EnablePivotTable();
  void put_EnablePivotTable(BOOL newValue);
  VARIANT Evaluate(VARIANT Name);
  VARIANT _Evaluate(VARIANT Name);
  BOOL get_FilterMode();
  void ResetAllPageBreaks();
  LPDISPATCH GroupBoxes(VARIANT IndexType);
  LPDISPATCH GroupObjects(VARIANT IndexType);
  LPDISPATCH Labels(VARIANT IndexType);
  LPDISPATCH Lines(VARIANT IndexType);
  LPDISPATCH ListBoxes(VARIANT IndexType);
  LPDISPATCH get_Names();
  LPDISPATCH OLEObjects(VARIANT IndexType);
  CString get_OnCalculate();
  void put_OnCalculate(LPCTSTR newValue);
  CString get_OnData();
  void put_OnData(LPCTSTR newValue);
  CString get_OnEntry();
  void put_OnEntry(LPCTSTR newValue);
  LPDISPATCH OptionButtons(VARIANT IndexType);
  LPDISPATCH get_Outline();
  LPDISPATCH Ovals(VARIANT IndexType);
  void Paste(VARIANT Destination, VARIANT Link);
  void _PasteSpecial(VARIANT Format, VARIANT Link, VARIANT DisplayAsIcon, VARIANT IconFileName, VARIANT IconIndex, VARIANT IconLabel);
  LPDISPATCH Pictures(VARIANT IndexType);
  LPDISPATCH PivotTables(VARIANT IndexType);
  LPDISPATCH PivotTableWizard(VARIANT SourceType, VARIANT DataStream, VARIANT TableDestination, VARIANT TableName, VARIANT RowGrand, VARIANT ColumnGrand, VARIANT SaveData, VARIANT HasAutoFormat, VARIANT AutoPage, VARIANT Reserved, VARIANT BackgroundQuery, VARIANT OptimizeCache, VARIANT PageFieldOrder, VARIANT PageFieldWrapCount, VARIANT ReadData, VARIANT Connection);
  LPDISPATCH get_Range(VARIANT Cell1, VARIANT Cell2);
  LPDISPATCH Rectangles(VARIANT IndexType);
  LPDISPATCH Scenarios(VARIANT IndexType);
  CString get_ScrollArea();
  void put_ScrollArea(LPCTSTR newValue);
  LPDISPATCH ScrollBars(VARIANT IndexType);
  void ShowAllData();
  void ShowDataForm();
  LPDISPATCH Spinners(VARIANT IndexType);
  double get_StandardHeight();
  double get_StandardWidth();
  void put_StandardWidth(double newValue);
  LPDISPATCH TextBoxes(VARIANT IndexType);
  BOOL get_TransitionFormEntry();
  void put_TransitionFormEntry(BOOL newValue);
  long get_Type();
  LPDISPATCH get_HPageBreaks();
  LPDISPATCH get_VPageBreaks();
  LPDISPATCH get_QueryTables();
  BOOL get_DisplayPageBreaks();
  void put_DisplayPageBreaks(BOOL newValue);
  LPDISPATCH get_Comments();
  LPDISPATCH get_Hyperlinks();
  void ClearCircles();
  void CircleInvalid();
  long get__DisplayRightToLeft();
  void put__DisplayRightToLeft(long newValue);
  LPDISPATCH get_AutoFilter();
  BOOL get_DisplayRightToLeft();
  void put_DisplayRightToLeft(BOOL newValue);
  LPDISPATCH get_Scripts();
  void _PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName);
  void _CheckSpelling(VARIANT CustomDictionary, VARIANT IgnoreUppercase, VARIANT AlwaysSuggest, VARIANT SpellLang, VARIANT IgnoreFinalYaa, VARIANT SpellScript);
  LPDISPATCH get_Tab();
  LPDISPATCH get_MailEnvelope();
  void SaveAs(LPCTSTR Filename, VARIANT FileFormat, VARIANT Password, VARIANT WriteResPassword, VARIANT ReadOnlyRecommended, VARIANT CreateBackup, VARIANT AddToMru, VARIANT TextCodepage, VARIANT TextVisualLayout, VARIANT Local);
  LPDISPATCH get_CustomProperties();
  LPDISPATCH get_SmartTags();
  LPDISPATCH get_Protection();
  void PasteSpecial(VARIANT Format, VARIANT Link, VARIANT DisplayAsIcon, VARIANT IconFileName, VARIANT IconIndex, VARIANT IconLabel, VARIANT NoHTMLFormatting);
  void Protect(VARIANT Password, VARIANT DrawingObjects, VARIANT Contents, VARIANT Scenarios, VARIANT UserInterfaceOnly, VARIANT AllowFormattingCells, VARIANT AllowFormattingColumns, VARIANT AllowFormattingRows, VARIANT AllowInsertingColumns, VARIANT AllowInsertingRows, VARIANT AllowInsertingHyperlinks, VARIANT AllowDeletingColumns, VARIANT AllowDeletingRows, VARIANT AllowSorting, VARIANT AllowFiltering, VARIANT AllowUsingPivotTables);
  LPDISPATCH get_ListObjects();
  LPDISPATCH XmlDataQuery(LPCTSTR XPath, VARIANT SelectionNamespaces, VARIANT Map);
  LPDISPATCH XmlMapQuery(LPCTSTR XPath, VARIANT SelectionNamespaces, VARIANT Map);
  void PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName, VARIANT IgnorePrintAreas);
  BOOL get_EnableFormatConditionsCalculation();
  void put_EnableFormatConditionsCalculation(BOOL newValue);
  LPDISPATCH get_Sort();
  void ExportAsFixedFormat(long Type, VARIANT Filename, VARIANT Quality, VARIANT IncludeDocProperties, VARIANT IgnorePrintAreas, VARIANT From, VARIANT To, VARIANT OpenAfterPublish, VARIANT FixedFormatExtClassPtr);
  long get_PrintedCommentPages();
};

} // namespace MSO::Excel
