#pragma once
// EXLWorksheets wrapper class

#include "office/MSCollection.hpp"
#include "office/VariantableDispatch.hpp"

namespace MSO::Excel {
  class EXLWorksheet;

class EXLWorksheets :
  public VariantableDispatch,
  public MSCollection<EXLWorksheets, EXLWorksheet> {
public:
  EXLWorksheets() = default;
  EXLWorksheets(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  EXLWorksheets(const EXLWorksheets& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  EXLWorksheet get_Item(VARIANT IndexType);
  size_type get_Count();
  EXLWorksheet Add(const EXLWorksheet& Before, const EXLWorksheet& After, VARIANT Count, VARIANT Type);
  EXLWorksheet Add2(const EXLWorksheet& Before, const EXLWorksheet& After, VARIANT Count, VARIANT NewLayout);
  void Copy(const EXLWorksheet& Before, const EXLWorksheet& After);
  void Move(const EXLWorksheet& Before, const EXLWorksheet& After);

  VARIANT get_Visible();
  void put_Visible(VARIANT newValue);

  void Delete();

  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  void FillAcrossSheets(LPDISPATCH Range, long Type);
  LPUNKNOWN get_NewEnum();
  void __PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate);
  void PrintPreview(VARIANT EnableChanges);
  void Select(VARIANT Replace);
  LPDISPATCH get_HPageBreaks();
  LPDISPATCH get_VPageBreaks();
  LPDISPATCH get__Default(VARIANT IndexType);
  void _PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName);
  void PrintOut(VARIANT From, VARIANT To, VARIANT Copies, VARIANT Preview, VARIANT ActivePrinter, VARIANT PrintToFile, VARIANT Collate, VARIANT PrToFileName, VARIANT IgnorePrintAreas);
};

} // namespace MSO::Excel
