#pragma once
// WApplication wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Word {
  class WApplication;

class WApplication : public VariantableDispatch {
public:
  WApplication() = default;
  WApplication(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WApplication(const WApplication& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  CString get_Name();
  LPDISPATCH get_Documents();
  LPDISPATCH get_Windows();
  LPDISPATCH get_ActiveDocument();
  LPDISPATCH get_ActiveWindow();
  LPDISPATCH get_Selection();
  LPDISPATCH get_WordBasic();
  LPDISPATCH get_RecentFiles();
  LPDISPATCH get_NormalTemplate();
  LPDISPATCH get_System();
  LPDISPATCH get_AutoCorrect();
  LPDISPATCH get_FontNames();
  LPDISPATCH get_LandscapeFontNames();
  LPDISPATCH get_PortraitFontNames();
  LPDISPATCH get_Languages();
  LPDISPATCH get_Assistant();
  LPDISPATCH get_Browser();
  LPDISPATCH get_FileConverters();
  LPDISPATCH get_MailingLabel();
  LPDISPATCH get_Dialogs();
  LPDISPATCH get_CaptionLabels();
  LPDISPATCH get_AutoCaptions();
  LPDISPATCH get_AddIns();
  BOOL get_Visible();
  void put_Visible(BOOL newValue);
  CString get_Version();
  BOOL get_ScreenUpdating();
  void put_ScreenUpdating(BOOL newValue);
  BOOL get_PrintPreview();
  void put_PrintPreview(BOOL newValue);
  LPDISPATCH get_Tasks();
  BOOL get_DisplayStatusBar();
  void put_DisplayStatusBar(BOOL newValue);
  BOOL get_SpecialMode();
  long get_UsableWidth();
  long get_UsableHeight();
  BOOL get_MathCoprocessorAvailable();
  BOOL get_MouseAvailable();
  VARIANT get_International(long IndexType);
  CString get_Build();
  BOOL get_CapsLock();
  BOOL get_NumLock();
  CString get_UserName();
  void put_UserName(LPCTSTR newValue);
  CString get_UserInitials();
  void put_UserInitials(LPCTSTR newValue);
  CString get_UserAddress();
  void put_UserAddress(LPCTSTR newValue);
  LPDISPATCH get_MacroContainer();
  BOOL get_DisplayRecentFiles();
  void put_DisplayRecentFiles(BOOL newValue);
  LPDISPATCH get_CommandBars();
  LPDISPATCH get_SynonymInfo(LPCTSTR MSWord, VARIANT * LanguageID);
  LPDISPATCH get_VBE();
  CString get_DefaultSaveFormat();
  void put_DefaultSaveFormat(LPCTSTR newValue);
  LPDISPATCH get_ListGalleries();
  CString get_ActivePrinter();
  void put_ActivePrinter(LPCTSTR newValue);
  LPDISPATCH get_Templates();
  LPDISPATCH get_CustomizationContext();
  void put_CustomizationContext(LPDISPATCH newValue);
  LPDISPATCH get_KeyBindings();
  LPDISPATCH get_KeysBoundTo(long KeyCategory, LPCTSTR Command, VARIANT * CommandParameter);
  LPDISPATCH get_FindKey(long KeyCode, VARIANT * KeyCode2);
  CString get_Caption();
  void put_Caption(LPCTSTR newValue);
  CString get_Path();
  BOOL get_DisplayScrollBars();
  void put_DisplayScrollBars(BOOL newValue);
  CString get_StartupPath();
  void put_StartupPath(LPCTSTR newValue);
  long get_BackgroundSavingStatus();
  long get_BackgroundPrintingStatus();
  long get_Left();
  void put_Left(long newValue);
  long get_Top();
  void put_Top(long newValue);
  long get_Width();
  void put_Width(long newValue);
  long get_Height();
  void put_Height(long newValue);
  long get_WindowState();
  void put_WindowState(long newValue);
  BOOL get_DisplayAutoCompleteTips();
  void put_DisplayAutoCompleteTips(BOOL newValue);
  LPDISPATCH get_Options();
  long get_DisplayAlerts();
  void put_DisplayAlerts(long newValue);
  LPDISPATCH get_CustomDictionaries();
  CString get_PathSeparator();
  void put_StatusBar(LPCTSTR newValue);
  BOOL get_MAPIAvailable();
  BOOL get_DisplayScreenTips();
  void put_DisplayScreenTips(BOOL newValue);
  long get_EnableCancelKey();
  void put_EnableCancelKey(long newValue);
  BOOL get_UserControl();
  LPDISPATCH get_FileSearch();
  long get_MailSystem();
  CString get_DefaultTableSeparator();
  void put_DefaultTableSeparator(LPCTSTR newValue);
  BOOL get_ShowVisualBasicEditor();
  void put_ShowVisualBasicEditor(BOOL newValue);
  CString get_BrowseExtraFileTypes();
  void put_BrowseExtraFileTypes(LPCTSTR newValue);
  BOOL get_IsObjectValid(LPDISPATCH Object);
  LPDISPATCH get_HangulHanjaDictionaries();
  LPDISPATCH get_MailMessage();
  BOOL get_FocusInMailHeader();
  void Quit(VARIANT * SaveChanges, VARIANT * OriginalFormat, VARIANT * RouteDocument);
  void ScreenRefresh();
  void PrintOutOld(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * FileName, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint);
  void LookupNameProperties(LPCTSTR Name);
  void SubstituteFont(LPCTSTR UnavailableFont, LPCTSTR SubstituteFont);
  BOOL Repeat(VARIANT * Times);
  void DDEExecute(long Channel, LPCTSTR Command);
  long DDEInitiate(LPCTSTR App, LPCTSTR Topic);
  void DDEPoke(long Channel, LPCTSTR Item, LPCTSTR Data);
  CString DDERequest(long Channel, LPCTSTR Item);
  void DDETerminate(long Channel);
  void DDETerminateAll();
  long BuildKeyCode(long Arg1, VARIANT * Arg2, VARIANT * Arg3, VARIANT * Arg4);
  CString KeyString(long KeyCode, VARIANT * KeyCode2);
  void OrganizerCopy(LPCTSTR src, LPCTSTR Destination, LPCTSTR Name, long Object);
  void OrganizerDelete(LPCTSTR src, LPCTSTR Name, long Object);
  void OrganizerRename(LPCTSTR src, LPCTSTR Name, LPCTSTR NewName, long Object);
  void AddAddress(SAFEARRAY * * TagID, SAFEARRAY * * Value);
  CString GetAddress(VARIANT * Name, VARIANT * AddressProperties, VARIANT * UseAutoText, VARIANT * DisplaySelectDialog, VARIANT * SelectDialog, VARIANT * CheckNamesDialog, VARIANT * RecentAddressesChoice, VARIANT * UpdateRecentAddresses);
  BOOL CheckGrammar(LPCTSTR String);
  BOOL CheckSpelling(LPCTSTR MSWord, VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * MainDictionary, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10);
  void ResetIgnoreAll();
  LPDISPATCH GetSpellingSuggestions(LPCTSTR MSWord, VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * MainDictionary, VARIANT * SuggestionMode, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10);
  void GoBack();
  void Help(VARIANT * HelpType);
  void AutomaticChange();
  void ShowMe();
  void HelpTool();
  LPDISPATCH NewWindow();
  void ListCommands(BOOL ListAllCommands);
  void ShowClipboard();
  void OnTime(VARIANT * When, LPCTSTR Name, VARIANT * Tolerance);
  void NextLetter();
  short MountVolume(LPCTSTR Zone, LPCTSTR Server, LPCTSTR Volume, VARIANT * User, VARIANT * UserPassword, VARIANT * VolumePassword);
  CString CleanString(LPCTSTR String);
  void SendFax();
  void ChangeFileOpenDirectory(LPCTSTR Path);
  void RunOld(LPCTSTR MacroName);
  void GoForward();
  void Move(long Left, long Top);
  void Resize(long Width, long Height);
  float InchesToPoints(float Inches);
  float CentimetersToPoints(float Centimeters);
  float MillimetersToPoints(float Millimeters);
  float PicasToPoints(float Picas);
  float LinesToPoints(float Lines);
  float PointsToInches(float Points);
  float PointsToCentimeters(float Points);
  float PointsToMillimeters(float Points);
  float PointsToPicas(float Points);
  float PointsToLines(float Points);
  void Activate();
  float PointsToPixels(float Points, VARIANT * fVertical);
  float PixelsToPoints(float Pixels, VARIANT * fVertical);
  void KeyboardLatin();
  void KeyboardBidi();
  void ToggleKeyboard();
  long Keyboard(long LangId);
  CString ProductCode();
  LPDISPATCH DefaultWebOptions();
  void DiscussionSupport(VARIANT * Range, VARIANT * cid, VARIANT * piCSE);
  void SetDefaultTheme(LPCTSTR Name, long DocumentType);
  CString GetDefaultTheme(long DocumentType);
  LPDISPATCH get_EmailOptions();
  long get_Language();
  LPDISPATCH get_COMAddIns();
  BOOL get_CheckLanguage();
  void put_CheckLanguage(BOOL newValue);
  LPDISPATCH get_LanguageSettings();
  BOOL get_Dummy1();
  LPDISPATCH get_AnswerWizard();
  long get_FeatureInstall();
  void put_FeatureInstall(long newValue);
  void PrintOut2000(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * FileName, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight);
  VARIANT Run(LPCTSTR MacroName, VARIANT * varg1, VARIANT * varg2, VARIANT * varg3, VARIANT * varg4, VARIANT * varg5, VARIANT * varg6, VARIANT * varg7, VARIANT * varg8, VARIANT * varg9, VARIANT * varg10, VARIANT * varg11, VARIANT * varg12, VARIANT * varg13, VARIANT * varg14, VARIANT * varg15, VARIANT * varg16, VARIANT * varg17, VARIANT * varg18, VARIANT * varg19, VARIANT * varg20, VARIANT * varg21, VARIANT * varg22, VARIANT * varg23, VARIANT * varg24, VARIANT * varg25, VARIANT * varg26, VARIANT * varg27, VARIANT * varg28, VARIANT * varg29, VARIANT * varg30);
  void PrintOut(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * FileName, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight);
  long get_AutomationSecurity();
  void put_AutomationSecurity(long newValue);
  LPDISPATCH get_FileDialog(long FileDialogType);
  CString get_EmailTemplate();
  void put_EmailTemplate(LPCTSTR newValue);
  BOOL get_ShowWindowsInTaskbar();
  void put_ShowWindowsInTaskbar(BOOL newValue);
  LPDISPATCH get_NewDocument();
  BOOL get_ShowStartupDialog();
  void put_ShowStartupDialog(BOOL newValue);
  LPDISPATCH get_AutoCorrectEmail();
  LPDISPATCH get_TaskPanes();
  BOOL get_DefaultLegalBlackline();
  void put_DefaultLegalBlackline(BOOL newValue);
  BOOL Dummy2();
  LPDISPATCH get_SmartTagRecognizers();
  LPDISPATCH get_SmartTagTypes();
  LPDISPATCH get_XMLNamespaces();
  void PutFocusInMailHeader();
  BOOL get_ArbitraryXMLSupportAvailable();
  CString get_BuildFull();
  CString get_BuildFeatureCrew();
  void LoadMasterList(LPCTSTR FileName);
  LPDISPATCH CompareDocuments(LPDISPATCH OriginalDocument, LPDISPATCH RevisedDocument, long Destination, long Granularity, BOOL CompareFormatting, BOOL CompareCaseChanges, BOOL CompareWhitespace, BOOL CompareTables, BOOL CompareHeaders, BOOL CompareFootnotes, BOOL CompareTextboxes, BOOL CompareFields, BOOL CompareComments, BOOL CompareMoves, LPCTSTR RevisedAuthor, BOOL IgnoreAllComparisonWarnings);
  LPDISPATCH MergeDocuments(LPDISPATCH OriginalDocument, LPDISPATCH RevisedDocument, long Destination, long Granularity, BOOL CompareFormatting, BOOL CompareCaseChanges, BOOL CompareWhitespace, BOOL CompareTables, BOOL CompareHeaders, BOOL CompareFootnotes, BOOL CompareTextboxes, BOOL CompareFields, BOOL CompareComments, BOOL CompareMoves, LPCTSTR OriginalAuthor, LPCTSTR RevisedAuthor, long FormatFrom);
  LPDISPATCH get_Bibliography();
  BOOL get_ShowStylePreviews();
  void put_ShowStylePreviews(BOOL newValue);
  BOOL get_RestrictLinkedStyles();
  void put_RestrictLinkedStyles(BOOL newValue);
  LPDISPATCH get_OMathAutoCorrect();
  BOOL get_DisplayDocumentInformationPanel();
  void put_DisplayDocumentInformationPanel(BOOL newValue);
  LPDISPATCH get_Assistance();
  BOOL get_OpenAttachmentsInFullScreen();
  void put_OpenAttachmentsInFullScreen(BOOL newValue);
  long get_ActiveEncryptionSession();
  BOOL get_DontResetInsertionPointProperties();
  void put_DontResetInsertionPointProperties(BOOL newValue);
  LPDISPATCH get_SmartArtLayouts();
  LPDISPATCH get_SmartArtQuickStyles();
  LPDISPATCH get_SmartArtColors();
  void ThreeWayMerge(LPDISPATCH LocalDocument, LPDISPATCH ServerDocument, LPDISPATCH BaseDocument, BOOL FavorSource);
  void Dummy4();
  LPDISPATCH get_UndoRecord();
  LPDISPATCH get_PickerDialog();
  LPDISPATCH get_ProtectedViewWindows();
  LPDISPATCH get_ActiveProtectedViewWindow();
  BOOL get_IsSandboxed();
  long get_FileValidation();
  void put_FileValidation(long newValue);
  BOOL get_ChartDataPointTrack();
  void put_ChartDataPointTrack(BOOL newValue);
  BOOL get_ShowAnimation();
  void put_ShowAnimation(BOOL newValue);
};

} // namespace MSO::Word
