#pragma once
// WBookmark wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Word {
  class WApplication;
  class WRange;

class WBookmark : public VariantableDispatch {
public:
  WBookmark() = default;
  WBookmark(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WBookmark(const WBookmark& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  CString get_Name();
  WRange get_Range();
  BOOL get_Empty();
  long get_Start();
  void put_Start(long newValue);
  long get_End();
  void put_End(long newValue);
  BOOL get_Column();
  long get_StoryType();
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  void Select();
  void Delete();
  LPDISPATCH Copy(LPCTSTR Name);
};

} // namespace MSO::Word
