#pragma once
// WBookmarks wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Word {
  class WBookmark;
  class WApplication;

class WBookmarks :
  public VariantableDispatch,
  public MSCollection<WBookmarks, WBookmark> {
public:
  WBookmarks() = default;
  WBookmarks(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WBookmarks(const WBookmarks& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPUNKNOWN get_NewEnum();
  long get_Count();
  long get_DefaultSorting();
  void put_DefaultSorting(long newValue);
  BOOL get_ShowHidden();
  void put_ShowHidden(BOOL newValue);
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  WBookmark get_Item(VARIANT IndexType);
  WBookmark Add(LPCTSTR Name, VARIANT * Range);
  BOOL Exists(LPCTSTR Name);
};

} // namespace MSO::Word
