#pragma once
// WCell wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Word {
  class WApplication;
  class WRange;
  class WColumn;
  class WRow;

class WCell : public VariantableDispatch {
public:
  WCell() = default;
  WCell(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WCell(const WCell& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  WRange get_Range();
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  long get_RowIndex();
  long get_ColumnIndex();
  float get_Width();
  void put_Width(float newValue);
  float get_Height();
  void put_Height(float newValue);
  long get_HeightRule();
  void put_HeightRule(long newValue);
  long get_VerticalAlignment();
  void put_VerticalAlignment(long newValue);
  WColumn get_Column();
  WRow get_Row();
  LPDISPATCH get_Next();
  LPDISPATCH get_Previous();
  LPDISPATCH get_Shading();
  LPDISPATCH get_Borders();
  void put_Borders(LPDISPATCH newValue);
  void Select();
  void Delete(VARIANT * ShiftCells);
  void Formula(VARIANT * Formula, VARIANT * NumFormat);
  void SetWidth(float ColumnWidth, long RulerStyle);
  void SetHeight(VARIANT * RowHeight, long HeightRule);
  void Merge(LPDISPATCH MergeTo);
  void Split(VARIANT * NumRows, VARIANT * NumColumns);
  void AutoSum();
  LPDISPATCH get_Tables();
  long get_NestingLevel();
  BOOL get_WordWrap();
  void put_WordWrap(BOOL newValue);
  float get_PreferredWidth();
  void put_PreferredWidth(float newValue);
  BOOL get_FitText();
  void put_FitText(BOOL newValue);
  float get_TopPadding();
  void put_TopPadding(float newValue);
  float get_BottomPadding();
  void put_BottomPadding(float newValue);
  float get_LeftPadding();
  void put_LeftPadding(float newValue);
  float get_RightPadding();
  void put_RightPadding(float newValue);
  CString get_ID();
  void put_ID(LPCTSTR newValue);
  long get_PreferredWidthType();
  void put_PreferredWidthType(long newValue);
};

} // namespace MSO::Word
