#pragma once
// WColumn wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Word {

class WColumn : public VariantableDispatch {
public:
  WColumn() = default;
  WColumn(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WColumn(const WColumn& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  float get_Width();
  void put_Width(float newValue);
  BOOL get_IsFirst();
  BOOL get_IsLast();
  long get_Index();
  LPDISPATCH get_Cells();
  LPDISPATCH get_Borders();
  void put_Borders(LPDISPATCH newValue);
  LPDISPATCH get_Shading();
  LPDISPATCH get_Next();
  LPDISPATCH get_Previous();
  void Select();
  void Delete();
  void SetWidth(float ColumnWidth, long RulerStyle);
  void AutoFit();
  void SortOld(VARIANT * ExcludeHeader, VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * CaseSensitive, VARIANT * LanguageID);
  void Sort(VARIANT * ExcludeHeader, VARIANT * SortFieldType, VARIANT * SortOrder, VARIANT * CaseSensitive, VARIANT * BidiSort, VARIANT * IgnoreThe, VARIANT * IgnoreKashida, VARIANT * IgnoreDiacritics, VARIANT * IgnoreHe, VARIANT * LanguageID);
  long get_NestingLevel();
  float get_PreferredWidth();
  void put_PreferredWidth(float newValue);
  long get_PreferredWidthType();
  void put_PreferredWidthType(long newValue);
};

} // namespace MSO::Word
