#pragma once
// WColumns wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Word {
  class WColumn;
  class WApplication;

class WColumns :
  public VariantableDispatch,
  public MSCollection<WColumns, WColumn> {
public:
  WColumns() = default;
  WColumns(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WColumns(const WColumns& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPUNKNOWN get_NewEnum();
  long get_Count();
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  WColumn get_First();
  WColumn get_Last();
  float get_Width();
  void put_Width(float newValue);
  LPDISPATCH get_Borders();
  void put_Borders(LPDISPATCH newValue);
  LPDISPATCH get_Shading();
  WColumn get_Item(long IndexType);
  WColumn Add(VARIANT * BeforeColumn);
  void Select();
  void Delete();
  void SetWidth(float ColumnWidth, long RulerStyle);
  void AutoFit();
  void DistributeWidth();
  long get_NestingLevel();
  float get_PreferredWidth();
  void put_PreferredWidth(float newValue);
  long get_PreferredWidthType();
  void put_PreferredWidthType(long newValue);
};

} // namespace MSO::Word
