#pragma once
// WComment wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Word {

class WComment : public VariantableDispatch {
public:
  WComment() = default;
  WComment(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WComment(const WComment& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  LPDISPATCH get_Range();
  LPDISPATCH get_Reference();
  LPDISPATCH get_Scope();
  long get_Index();
  CString get_Author();
  void put_Author(LPCTSTR newValue);
  CString get_Initial();
  void put_Initial(LPCTSTR newValue);
  BOOL get_ShowTip();
  void put_ShowTip(BOOL newValue);
  void Delete();
  void Edit();
  DATE get_Date();
  BOOL get_IsInk();
  BOOL get_Done();
  void put_Done(BOOL newValue);
  LPDISPATCH get_Ancestor();
  LPDISPATCH get_Contact();
  void DeleteRecursively();
  LPDISPATCH get_Replies();
};

} // namespace MSO::Word
