#pragma once
// WComments wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Word {
  class WRange;
  class WComment;

class WComments :
  public VariantableDispatch,
  public MSCollection<WComments, WComment> {
public:
  WComments() = default;
  WComments(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WComments(const WComments& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPUNKNOWN get_NewEnum();
  long get_Count();
  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  CString get_ShowBy();
  void put_ShowBy(LPCTSTR newValue);
  LPDISPATCH get_Item(long IndexType);
  LPDISPATCH Add(WRange Range, VARIANT * Text);
};

} // namespace MSO::Word
