#pragma once
// WDocument wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Word {
  class WTables;
  class WBookmarks;
  class WApplication;

class WDocument : public VariantableDispatch {
public:
  WDocument() = default;
  WDocument(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WDocument(const WDocument& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  CString get_Name();
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  LPDISPATCH get_BuiltInDocumentProperties();
  LPDISPATCH get_CustomDocumentProperties();
  CString get_Path();
  WBookmarks get_Bookmarks();
  WTables get_Tables();
  LPDISPATCH get_Footnotes();
  LPDISPATCH get_Endnotes();
  LPDISPATCH get_Comments();
  long get_Type();
  BOOL get_AutoHyphenation();
  void put_AutoHyphenation(BOOL newValue);
  BOOL get_HyphenateCaps();
  void put_HyphenateCaps(BOOL newValue);
  long get_HyphenationZone();
  void put_HyphenationZone(long newValue);
  long get_ConsecutiveHyphensLimit();
  void put_ConsecutiveHyphensLimit(long newValue);
  LPDISPATCH get_Sections();
  LPDISPATCH get_Paragraphs();
  LPDISPATCH get_Words();
  LPDISPATCH get_Sentences();
  LPDISPATCH get_Characters();
  LPDISPATCH get_Fields();
  LPDISPATCH get_FormFields();
  LPDISPATCH get_Styles();
  LPDISPATCH get_Frames();
  LPDISPATCH get_TablesOfFigures();
  LPDISPATCH get_Variables();
  LPDISPATCH get_MailMerge();
  LPDISPATCH get_Envelope();
  CString get_FullName();
  LPDISPATCH get_Revisions();
  LPDISPATCH get_TablesOfContents();
  LPDISPATCH get_TablesOfAuthorities();
  LPDISPATCH get_PageSetup();
  void put_PageSetup(LPDISPATCH newValue);
  LPDISPATCH get_Windows();
  BOOL get_HasRoutingSlip();
  void put_HasRoutingSlip(BOOL newValue);
  LPDISPATCH get_RoutingSlip();
  BOOL get_Routed();
  LPDISPATCH get_TablesOfAuthoritiesCategories();
  LPDISPATCH get_Indexes();
  BOOL get_Saved();
  void put_Saved(BOOL newValue);
  LPDISPATCH get_Content();
  LPDISPATCH get_ActiveWindow();
  long get_Kind();
  void put_Kind(long newValue);
  BOOL get_ReadOnly();
  LPDISPATCH get_Subdocuments();
  BOOL get_IsMasterDocument();
  float get_DefaultTabStop();
  void put_DefaultTabStop(float newValue);
  BOOL get_EmbedTrueTypeFonts();
  void put_EmbedTrueTypeFonts(BOOL newValue);
  BOOL get_SaveFormsData();
  void put_SaveFormsData(BOOL newValue);
  BOOL get_ReadOnlyRecommended();
  void put_ReadOnlyRecommended(BOOL newValue);
  BOOL get_SaveSubsetFonts();
  void put_SaveSubsetFonts(BOOL newValue);
  BOOL get_Compatibility(long Type);
  void put_Compatibility(long Type, BOOL newValue);
  LPDISPATCH get_StoryRanges();
  LPDISPATCH get_CommandBars();
  BOOL get_IsSubdocument();
  long get_SaveFormat();
  long get_ProtectionType();
  LPDISPATCH get_Hyperlinks();
  LPDISPATCH get_Shapes();
  LPDISPATCH get_ListTemplates();
  LPDISPATCH get_Lists();
  BOOL get_UpdateStylesOnOpen();
  void put_UpdateStylesOnOpen(BOOL newValue);
  VARIANT get_AttachedTemplate();
  void put_AttachedTemplate(VARIANT * newValue);
  LPDISPATCH get_InlineShapes();
  LPDISPATCH get_Background();
  void put_Background(LPDISPATCH newValue);
  BOOL get_GrammarChecked();
  void put_GrammarChecked(BOOL newValue);
  BOOL get_SpellingChecked();
  void put_SpellingChecked(BOOL newValue);
  BOOL get_ShowGrammaticalErrors();
  void put_ShowGrammaticalErrors(BOOL newValue);
  BOOL get_ShowSpellingErrors();
  void put_ShowSpellingErrors(BOOL newValue);
  LPDISPATCH get_Versions();
  BOOL get_ShowSummary();
  void put_ShowSummary(BOOL newValue);
  long get_SummaryViewMode();
  void put_SummaryViewMode(long newValue);
  long get_SummaryLength();
  void put_SummaryLength(long newValue);
  BOOL get_PrintFractionalWidths();
  void put_PrintFractionalWidths(BOOL newValue);
  BOOL get_PrintPostScriptOverText();
  void put_PrintPostScriptOverText(BOOL newValue);
  LPDISPATCH get_Container();
  BOOL get_PrintFormsData();
  void put_PrintFormsData(BOOL newValue);
  LPDISPATCH get_ListParagraphs();
  void put_Password(LPCTSTR newValue);
  void put_WritePassword(LPCTSTR newValue);
  BOOL get_HasPassword();
  BOOL get_WriteReserved();
  CString get_ActiveWritingStyle(VARIANT * LanguageID);
  void put_ActiveWritingStyle(VARIANT * LanguageID, LPCTSTR newValue);
  BOOL get_UserControl();
  void put_UserControl(BOOL newValue);
  BOOL get_HasMailer();
  void put_HasMailer(BOOL newValue);
  LPDISPATCH get_Mailer();
  LPDISPATCH get_ReadabilityStatistics();
  LPDISPATCH get_GrammaticalErrors();
  LPDISPATCH get_SpellingErrors();
  LPDISPATCH get_VBProject();
  BOOL get_FormsDesign();
  CString get__CodeName();
  void put__CodeName(LPCTSTR newValue);
  CString get_CodeName();
  BOOL get_SnapToGrid();
  void put_SnapToGrid(BOOL newValue);
  BOOL get_SnapToShapes();
  void put_SnapToShapes(BOOL newValue);
  float get_GridDistanceHorizontal();
  void put_GridDistanceHorizontal(float newValue);
  float get_GridDistanceVertical();
  void put_GridDistanceVertical(float newValue);
  float get_GridOriginHorizontal();
  void put_GridOriginHorizontal(float newValue);
  float get_GridOriginVertical();
  void put_GridOriginVertical(float newValue);
  long get_GridSpaceBetweenHorizontalLines();
  void put_GridSpaceBetweenHorizontalLines(long newValue);
  long get_GridSpaceBetweenVerticalLines();
  void put_GridSpaceBetweenVerticalLines(long newValue);
  BOOL get_GridOriginFromMargin();
  void put_GridOriginFromMargin(BOOL newValue);
  BOOL get_KerningByAlgorithm();
  void put_KerningByAlgorithm(BOOL newValue);
  long get_JustificationMode();
  void put_JustificationMode(long newValue);
  long get_FarEastLineBreakLevel();
  void put_FarEastLineBreakLevel(long newValue);
  CString get_NoLineBreakBefore();
  void put_NoLineBreakBefore(LPCTSTR newValue);
  CString get_NoLineBreakAfter();
  void put_NoLineBreakAfter(LPCTSTR newValue);
  BOOL get_TrackRevisions();
  void put_TrackRevisions(BOOL newValue);
  BOOL get_PrintRevisions();
  void put_PrintRevisions(BOOL newValue);
  BOOL get_ShowRevisions();
  void put_ShowRevisions(BOOL newValue);
  void Close(VARIANT * SaveChanges, VARIANT * OriginalFormat, VARIANT * RouteDocument);
  void SaveAs2000(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter);
  void Repaginate();
  void FitToPages();
  void ManualHyphenation();
  void Select();
  void DataForm();
  void Route();
  void Save();
  void PrintOutOld(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint);
  void SendMail();
  LPDISPATCH Range(VARIANT * Start, VARIANT * End);
  void RunAutoMacro(long Which);
  void Activate();
  void PrintPreview();
  LPDISPATCH GoTo(VARIANT * What, VARIANT * Which, VARIANT * Count, VARIANT * Name);
  BOOL Undo(VARIANT * Times);
  BOOL Redo(VARIANT * Times);
  long ComputeStatistics(long Statistic, VARIANT * IncludeFootnotesAndEndnotes);
  void MakeCompatibilityDefault();
  void Protect2002(long Type, VARIANT * NoReset, VARIANT * Password);
  void Unprotect(VARIANT * Password);
  void EditionOptions(long Type, long Option, LPCTSTR Name, VARIANT * Format);
  void RunLetterWizard(VARIANT * LetterContent, VARIANT * WizardMode);
  LPDISPATCH GetLetterContent();
  void SetLetterContent(VARIANT * LetterContent);
  void CopyStylesFromTemplate(LPCTSTR Template);
  void UpdateStyles();
  void CheckGrammar();
  void CheckSpelling(VARIANT * CustomDictionary, VARIANT * IgnoreUppercase, VARIANT * AlwaysSuggest, VARIANT * CustomDictionary2, VARIANT * CustomDictionary3, VARIANT * CustomDictionary4, VARIANT * CustomDictionary5, VARIANT * CustomDictionary6, VARIANT * CustomDictionary7, VARIANT * CustomDictionary8, VARIANT * CustomDictionary9, VARIANT * CustomDictionary10);
  void FollowHyperlink(VARIANT * Address, VARIANT * SubAddress, VARIANT * NewWindow, VARIANT * AddHistory, VARIANT * ExtraInfo, VARIANT * Method, VARIANT * HeaderInfo);
  void AddToFavorites();
  void Reload();
  LPDISPATCH AutoSummarize(VARIANT * Length, VARIANT * Mode, VARIANT * UpdateProperties);
  void RemoveNumbers(VARIANT * NumberType);
  void ConvertNumbersToText(VARIANT * NumberType);
  long CountNumberedItems(VARIANT * NumberType, VARIANT * Level);
  void Post();
  void ToggleFormsDesign();
  void Compare2000(LPCTSTR Name);
  void UpdateSummaryProperties();
  VARIANT GetCrossReferenceItems(VARIANT * ReferenceType);
  void AutoFormat();
  void ViewCode();
  void ViewPropertyBrowser();
  void ForwardMailer();
  void Reply();
  void ReplyAll();
  void SendMailer(VARIANT * FileFormat, VARIANT * Priority);
  void UndoClear();
  void PresentIt();
  void SendFax(LPCTSTR Address, VARIANT * Subject);
  void Merge2000(LPCTSTR FileName);
  void ClosePrintPreview();
  void CheckConsistency();
  LPDISPATCH CreateLetterContent(LPCTSTR DateFormat, BOOL IncludeHeaderFooter, LPCTSTR PageDesign, long LetterStyle, BOOL Letterhead, long LetterheadLocation, float LetterheadSize, LPCTSTR RecipientName, LPCTSTR RecipientAddress, LPCTSTR Salutation, long SalutationType, LPCTSTR RecipientReference, LPCTSTR MailingInstructions, LPCTSTR AttentionLine, LPCTSTR Subject, LPCTSTR CCList, LPCTSTR ReturnAddress, LPCTSTR SenderName, LPCTSTR Closing, LPCTSTR SenderCompany, LPCTSTR SenderJobTitle, LPCTSTR SenderInitials, long EnclosureNumber, VARIANT * InfoBlock, VARIANT * RecipientCode, VARIANT * RecipientGender, VARIANT * ReturnAddressShortForm, VARIANT * SenderCity, VARIANT * SenderCode, VARIANT * SenderGender, VARIANT * SenderReference);
  void AcceptAllRevisions();
  void RejectAllRevisions();
  void DetectLanguage();
  void ApplyTheme(LPCTSTR Name);
  void RemoveTheme();
  void WebPagePreview();
  void ReloadAs(long Encoding);
  CString get_ActiveTheme();
  CString get_ActiveThemeDisplayName();
  LPDISPATCH get_Email();
  LPDISPATCH get_Scripts();
  BOOL get_LanguageDetected();
  void put_LanguageDetected(BOOL newValue);
  long get_FarEastLineBreakLanguage();
  void put_FarEastLineBreakLanguage(long newValue);
  LPDISPATCH get_Frameset();
  VARIANT get_ClickAndTypeParagraphStyle();
  void put_ClickAndTypeParagraphStyle(VARIANT * newValue);
  LPDISPATCH get_HTMLProject();
  LPDISPATCH get_WebOptions();
  long get_OpenEncoding();
  long get_SaveEncoding();
  void put_SaveEncoding(long newValue);
  BOOL get_OptimizeForWord97();
  void put_OptimizeForWord97(BOOL newValue);
  BOOL get_VBASigned();
  void PrintOut2000(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight);
  void sblt(LPCTSTR s);
  void ConvertVietDoc(long CodePageOrigin);
  void PrintOut(VARIANT * Background, VARIANT * Append, VARIANT * Range, VARIANT * OutputFileName, VARIANT * From, VARIANT * To, VARIANT * Item, VARIANT * Copies, VARIANT * Pages, VARIANT * PageType, VARIANT * PrintToFile, VARIANT * Collate, VARIANT * ActivePrinterMacGX, VARIANT * ManualDuplexPrint, VARIANT * PrintZoomColumn, VARIANT * PrintZoomRow, VARIANT * PrintZoomPaperWidth, VARIANT * PrintZoomPaperHeight);
  LPDISPATCH get_MailEnvelope();
  BOOL get_DisableFeatures();
  void put_DisableFeatures(BOOL newValue);
  BOOL get_DoNotEmbedSystemFonts();
  void put_DoNotEmbedSystemFonts(BOOL newValue);
  LPDISPATCH get_Signatures();
  CString get_DefaultTargetFrame();
  void put_DefaultTargetFrame(LPCTSTR newValue);
  LPDISPATCH get_HTMLDivisions();
  long get_DisableFeaturesIntroducedAfter();
  void put_DisableFeaturesIntroducedAfter(long newValue);
  BOOL get_RemovePersonalInformation();
  void put_RemovePersonalInformation(BOOL newValue);
  LPDISPATCH get_SmartTags();
  void Compare2002(LPCTSTR Name, VARIANT * AuthorName, VARIANT * CompareTarget, VARIANT * DetectFormatChanges, VARIANT * IgnoreAllComparisonWarnings, VARIANT * AddToRecentFiles);
  void CheckIn(BOOL SaveChanges, VARIANT * Comments, BOOL MakePublic);
  BOOL CanCheckin();
  void Merge(LPCTSTR FileName, VARIANT * MergeTarget, VARIANT * DetectFormatChanges, VARIANT * UseFormattingFrom, VARIANT * AddToRecentFiles);
  BOOL get_EmbedSmartTags();
  void put_EmbedSmartTags(BOOL newValue);
  BOOL get_SmartTagsAsXMLProps();
  void put_SmartTagsAsXMLProps(BOOL newValue);
  long get_TextEncoding();
  void put_TextEncoding(long newValue);
  long get_TextLineEnding();
  void put_TextLineEnding(long newValue);
  void SendForReview(VARIANT * Recipients, VARIANT * Subject, VARIANT * ShowMessage, VARIANT * IncludeAttachment);
  void ReplyWithChanges(VARIANT * ShowMessage);
  void EndReview();
  LPDISPATCH get_StyleSheets();
  VARIANT get_DefaultTableStyle();
  CString get_PasswordEncryptionProvider();
  CString get_PasswordEncryptionAlgorithm();
  long get_PasswordEncryptionKeyLength();
  BOOL get_PasswordEncryptionFileProperties();
  void SetPasswordEncryptionOptions(LPCTSTR PasswordEncryptionProvider, LPCTSTR PasswordEncryptionAlgorithm, long PasswordEncryptionKeyLength, VARIANT * PasswordEncryptionFileProperties);
  void RecheckSmartTags();
  void RemoveSmartTags();
  void SetDefaultTableStyle(VARIANT * Style, BOOL SetInTemplate);
  void DeleteAllComments();
  void AcceptAllRevisionsShown();
  void RejectAllRevisionsShown();
  void DeleteAllCommentsShown();
  void ResetFormFields();
  void SaveAs(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter, VARIANT * Encoding, VARIANT * InsertLineBreaks, VARIANT * AllowSubstitutions, VARIANT * LineEnding, VARIANT * AddBiDiMarks);
  BOOL get_EmbedLinguisticData();
  void put_EmbedLinguisticData(BOOL newValue);
  BOOL get_FormattingShowFont();
  void put_FormattingShowFont(BOOL newValue);
  BOOL get_FormattingShowClear();
  void put_FormattingShowClear(BOOL newValue);
  BOOL get_FormattingShowParagraph();
  void put_FormattingShowParagraph(BOOL newValue);
  BOOL get_FormattingShowNumbering();
  void put_FormattingShowNumbering(BOOL newValue);
  long get_FormattingShowFilter();
  void put_FormattingShowFilter(long newValue);
  void CheckNewSmartTags();
  LPDISPATCH get_Permission();
  LPDISPATCH get_XMLNodes();
  LPDISPATCH get_XMLSchemaReferences();
  LPDISPATCH get_SmartDocument();
  LPDISPATCH get_SharedWorkspace();
  LPDISPATCH get_Sync();
  BOOL get_EnforceStyle();
  void put_EnforceStyle(BOOL newValue);
  BOOL get_AutoFormatOverride();
  void put_AutoFormatOverride(BOOL newValue);
  BOOL get_XMLSaveDataOnly();
  void put_XMLSaveDataOnly(BOOL newValue);
  BOOL get_XMLHideNamespaces();
  void put_XMLHideNamespaces(BOOL newValue);
  BOOL get_XMLShowAdvancedErrors();
  void put_XMLShowAdvancedErrors(BOOL newValue);
  BOOL get_XMLUseXSLTWhenSaving();
  void put_XMLUseXSLTWhenSaving(BOOL newValue);
  CString get_XMLSaveThroughXSLT();
  void put_XMLSaveThroughXSLT(LPCTSTR newValue);
  LPDISPATCH get_DocumentLibraryVersions();
  BOOL get_ReadingModeLayoutFrozen();
  void put_ReadingModeLayoutFrozen(BOOL newValue);
  BOOL get_RemoveDateAndTime();
  void put_RemoveDateAndTime(BOOL newValue);
  void SendFaxOverInternet(VARIANT * Recipients, VARIANT * Subject, VARIANT * ShowMessage);
  void TransformDocument(LPCTSTR Path, BOOL DataOnly);
  void Protect(long Type, VARIANT * NoReset, VARIANT * Password, VARIANT * UseIRM, VARIANT * EnforceStyleLock);
  void SelectAllEditableRanges(VARIANT * EditorID);
  void DeleteAllEditableRanges(VARIANT * EditorID);
  void DeleteAllInkAnnotations();
  void AddDocumentWorkspaceHeader(BOOL RichFormat, LPCTSTR Url, LPCTSTR Title, LPCTSTR Description, LPCTSTR ID);
  void RemoveDocumentWorkspaceHeader(LPCTSTR ID);
  void Compare(LPCTSTR Name, VARIANT * AuthorName, VARIANT * CompareTarget, VARIANT * DetectFormatChanges, VARIANT * IgnoreAllComparisonWarnings, VARIANT * AddToRecentFiles, VARIANT * RemovePersonalInformation, VARIANT * RemoveDateAndTime);
  void RemoveLockedStyles();
  LPDISPATCH get_ChildNodeSuggestions();
  LPDISPATCH SelectSingleNode(LPCTSTR XPath, LPCTSTR PrefixMapping, BOOL FastSearchSkippingTextNodes);
  LPDISPATCH SelectNodes(LPCTSTR XPath, LPCTSTR PrefixMapping, BOOL FastSearchSkippingTextNodes);
  LPDISPATCH get_XMLSchemaViolations();
  long get_ReadingLayoutSizeX();
  void put_ReadingLayoutSizeX(long newValue);
  long get_ReadingLayoutSizeY();
  void put_ReadingLayoutSizeY(long newValue);
  long get_StyleSortMethod();
  void put_StyleSortMethod(long newValue);
  LPDISPATCH get_ContentTypeProperties();
  BOOL get_TrackMoves();
  void put_TrackMoves(BOOL newValue);
  BOOL get_TrackFormatting();
  void put_TrackFormatting(BOOL newValue);
  void get_Dummy1();
  LPDISPATCH get_OMaths();
  void RemoveDocumentInformation(long RemoveDocInfoType);
  void CheckInWithVersion(BOOL SaveChanges, VARIANT * Comments, BOOL MakePublic, VARIANT * VersionType);
  void Dummy2();
  void get_Dummy3();
  LPDISPATCH get_ServerPolicy();
  LPDISPATCH get_ContentControls();
  LPDISPATCH get_DocumentInspectors();
  void LockServerFile();
  LPDISPATCH GetWorkflowTasks();
  LPDISPATCH GetWorkflowTemplates();
  void Dummy4();
  void AddMeetingWorkspaceHeader(BOOL SkipIfAbsent, LPCTSTR Url, LPCTSTR Title, LPCTSTR Description, LPCTSTR ID);
  LPDISPATCH get_Bibliography();
  BOOL get_LockTheme();
  void put_LockTheme(BOOL newValue);
  BOOL get_LockQuickStyleSet();
  void put_LockQuickStyleSet(BOOL newValue);
  CString get_OriginalDocumentTitle();
  CString get_RevisedDocumentTitle();
  LPDISPATCH get_CustomXMLParts();
  BOOL get_FormattingShowNextLevel();
  void put_FormattingShowNextLevel(BOOL newValue);
  BOOL get_FormattingShowUserStyleName();
  void put_FormattingShowUserStyleName(BOOL newValue);
  void SaveAsQuickStyleSet(LPCTSTR FileName);
  void ApplyQuickStyleSet(LPCTSTR Name);
  LPDISPATCH get_Research();
  BOOL get_Final();
  void put_Final(BOOL newValue);
  long get_OMathBreakBin();
  void put_OMathBreakBin(long newValue);
  long get_OMathBreakSub();
  void put_OMathBreakSub(long newValue);
  long get_OMathJc();
  void put_OMathJc(long newValue);
  float get_OMathLeftMargin();
  void put_OMathLeftMargin(float newValue);
  float get_OMathRightMargin();
  void put_OMathRightMargin(float newValue);
  float get_OMathWrap();
  void put_OMathWrap(float newValue);
  BOOL get_OMathIntSubSupLim();
  void put_OMathIntSubSupLim(BOOL newValue);
  BOOL get_OMathNarySupSubLim();
  void put_OMathNarySupSubLim(BOOL newValue);
  BOOL get_OMathSmallFrac();
  void put_OMathSmallFrac(BOOL newValue);
  CString get_WordOpenXML();
  LPDISPATCH get_DocumentTheme();
  void ApplyDocumentTheme(LPCTSTR FileName);
  BOOL get_HasVBProject();
  LPDISPATCH SelectLinkedControls(LPDISPATCH Node);
  LPDISPATCH SelectUnlinkedControls(LPDISPATCH Stream);
  LPDISPATCH SelectContentControlsByTitle(LPCTSTR Title);
  void ExportAsFixedFormat(LPCTSTR OutputFileName, long ExportFormat, BOOL OpenAfterExport, long OptimizeFor, long Range, long From, long To, long Item, BOOL IncludeDocProps, BOOL KeepIRM, long CreateBookmarks, BOOL DocStructureTags, BOOL BitmapMissingFonts, BOOL UseISO19005_1, VARIANT * FixedFormatExtClassPtr);
  void FreezeLayout();
  void UnfreezeLayout();
  CString get_OMathFontName();
  void put_OMathFontName(LPCTSTR newValue);
  void DowngradeDocument();
  CString get_EncryptionProvider();
  void put_EncryptionProvider(LPCTSTR newValue);
  BOOL get_UseMathDefaults();
  void put_UseMathDefaults(BOOL newValue);
  long get_CurrentRsid();
  void Convert();
  LPDISPATCH SelectContentControlsByTag(LPCTSTR Tag);
  void ConvertAutoHyphens();
  long get_DocID();
  void ApplyQuickStyleSet2(VARIANT * Style);
  long get_CompatibilityMode();
  void SaveAs2(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter, VARIANT * Encoding, VARIANT * InsertLineBreaks, VARIANT * AllowSubstitutions, VARIANT * LineEnding, VARIANT * AddBiDiMarks, VARIANT * CompatibilityMode);
  LPDISPATCH get_CoAuthoring();
  void SetCompatibilityMode(long Mode);
  LPDISPATCH get_Broadcast();
  long ReturnToLastReadPosition();
  BOOL get_ChartDataPointTrack();
  void put_ChartDataPointTrack(BOOL newValue);
  BOOL get_IsInAutosave();
  void SaveCopyAs(VARIANT * FileName, VARIANT * FileFormat, VARIANT * LockComments, VARIANT * Password, VARIANT * AddToRecentFiles, VARIANT * WritePassword, VARIANT * ReadOnlyRecommended, VARIANT * EmbedTrueTypeFonts, VARIANT * SaveNativePictureFormat, VARIANT * SaveFormsData, VARIANT * SaveAsAOCELetter, VARIANT * Encoding, VARIANT * InsertLineBreaks, VARIANT * AllowSubstitutions, VARIANT * LineEnding, VARIANT * AddBiDiMarks, VARIANT * CompatibilityMode);
  void InsertAppForOfficeTest(LPCTSTR ID, long Type, LPCTSTR Version, long StoreType, LPCTSTR StoreId, LPCTSTR AssetId, LPCTSTR AssetStoreId, long Width, long Height);
};

} // namespace MSO::Word
