#pragma once
// WDocumentsCollection wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Word {
  class WApplication;
  class WDocument;

class WDocuments :
  public VariantableDispatch,
  public MSCollection<WDocuments, WDocument> {
public:
  WDocuments() = default;
  explicit WDocuments(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WDocuments(const WDocuments& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPUNKNOWN get_NewEnum();
  long get_Count();
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  WDocument get_Item(VARIANT IndexType);
  void Close(VARIANT * SaveChanges, VARIANT * OriginalFormat, VARIANT * RouteDocument);
  WDocument AddOld(VARIANT * Template, VARIANT * NewTemplate);
  WDocument OpenOld(VARIANT * FileName, VARIANT * ConfirmConversions, VARIANT * ReadOnly, VARIANT * AddToRecentFiles, VARIANT * PasswordDocument, VARIANT * PasswordTemplate, VARIANT * Revert, VARIANT * WritePasswordDocument, VARIANT * WritePasswordTemplate, VARIANT * Format);
  void Save(VARIANT * NoPrompt, VARIANT * OriginalFormat);
  WDocument Add(VARIANT * Template, VARIANT * NewTemplate, VARIANT * DocumentType, VARIANT * Visible);
  WDocument Open2000(VARIANT * FileName, VARIANT * ConfirmConversions, VARIANT * ReadOnly, VARIANT * AddToRecentFiles, VARIANT * PasswordDocument, VARIANT * PasswordTemplate, VARIANT * Revert, VARIANT * WritePasswordDocument, VARIANT * WritePasswordTemplate, VARIANT * Format, VARIANT * Encoding, VARIANT * Visible);
  void CheckOut(LPCTSTR FileName);
  BOOL CanCheckOut(LPCTSTR FileName);
  WDocument Open2002(VARIANT * FileName, VARIANT * ConfirmConversions, VARIANT * ReadOnly, VARIANT * AddToRecentFiles, VARIANT * PasswordDocument, VARIANT * PasswordTemplate, VARIANT * Revert, VARIANT * WritePasswordDocument, VARIANT * WritePasswordTemplate, VARIANT * Format, VARIANT * Encoding, VARIANT * Visible, VARIANT * OpenAndRepair, VARIANT * DocumentDirection, VARIANT * NoEncodingDialog);
  WDocument Open(VARIANT * FileName, VARIANT * ConfirmConversions, VARIANT * ReadOnly, VARIANT * AddToRecentFiles, VARIANT * PasswordDocument, VARIANT * PasswordTemplate, VARIANT * Revert, VARIANT * WritePasswordDocument, VARIANT * WritePasswordTemplate, VARIANT * Format, VARIANT * Encoding, VARIANT * Visible, VARIANT * OpenAndRepair, VARIANT * DocumentDirection, VARIANT * NoEncodingDialog, VARIANT * XMLTransform);
  WDocument OpenNoRepairDialog(VARIANT * FileName, VARIANT * ConfirmConversions, VARIANT * ReadOnly, VARIANT * AddToRecentFiles, VARIANT * PasswordDocument, VARIANT * PasswordTemplate, VARIANT * Revert, VARIANT * WritePasswordDocument, VARIANT * WritePasswordTemplate, VARIANT * Format, VARIANT * Encoding, VARIANT * Visible, VARIANT * OpenAndRepair, VARIANT * DocumentDirection, VARIANT * NoEncodingDialog, VARIANT * XMLTransform);
  LPDISPATCH AddBlogDocument(LPCTSTR ProviderID, LPCTSTR PostURL, LPCTSTR BlogName, LPCTSTR PostID);

};

} // namespace MSO::Word
