#pragma once
// WRow wrapper class

#include "office/VariantableDispatch.hpp"

namespace MSO::Word {

class WRow : public VariantableDispatch {
public:
  WRow() = default;
  WRow(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WRow(const WRow& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPDISPATCH get_Range();
  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  long get_AllowBreakAcrossPages();
  void put_AllowBreakAcrossPages(long newValue);
  long get_Alignment();
  void put_Alignment(long newValue);
  long get_HeadingFormat();
  void put_HeadingFormat(long newValue);
  float get_SpaceBetweenColumns();
  void put_SpaceBetweenColumns(float newValue);
  float get_Height();
  void put_Height(float newValue);
  long get_HeightRule();
  void put_HeightRule(long newValue);
  float get_LeftIndent();
  void put_LeftIndent(float newValue);
  BOOL get_IsLast();
  BOOL get_IsFirst();
  long get_Index();
  LPDISPATCH get_Cells();
  LPDISPATCH get_Borders();
  void put_Borders(LPDISPATCH newValue);
  LPDISPATCH get_Shading();
  LPDISPATCH get_Next();
  LPDISPATCH get_Previous();
  void Select();
  void Delete();
  void SetLeftIndent(float LeftIndent, long RulerStyle);
  void SetHeight(float RowHeight, long HeightRule);
  LPDISPATCH ConvertToTextOld(VARIANT * Separator);
  LPDISPATCH ConvertToText(VARIANT * Separator, VARIANT * NestedTables);
  long get_NestingLevel();
  CString get_ID();
  void put_ID(LPCTSTR newValue);
};

} // namespace MSO::Word
