#pragma once
// WRows wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Word {
  class WRow;

class WRows :
  public VariantableDispatch,
  public MSCollection<WRows, WRow> {
public:
  WRows() = default;
  WRows(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WRows(const WRows& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPUNKNOWN get_NewEnum();
  long get_Count();
  long get_AllowBreakAcrossPages();
  void put_AllowBreakAcrossPages(long newValue);
  long get_Alignment();
  void put_Alignment(long newValue);
  long get_HeadingFormat();
  void put_HeadingFormat(long newValue);
  float get_SpaceBetweenColumns();
  void put_SpaceBetweenColumns(float newValue);
  float get_Height();
  void put_Height(float newValue);
  long get_HeightRule();
  void put_HeightRule(long newValue);
  float get_LeftIndent();
  void put_LeftIndent(float newValue);
  LPDISPATCH get_First();
  LPDISPATCH get_Last();
  LPDISPATCH get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  LPDISPATCH get_Borders();
  void put_Borders(LPDISPATCH newValue);
  LPDISPATCH get_Shading();
  LPDISPATCH get_Item(long IndexType);
  LPDISPATCH Add(VARIANT * BeforeRow);
  void Select();
  void Delete();
  void SetLeftIndent(float LeftIndent, long RulerStyle);
  void SetHeight(float RowHeight, long HeightRule);
  LPDISPATCH ConvertToTextOld(VARIANT * Separator);
  void DistributeHeight();
  LPDISPATCH ConvertToText(VARIANT * Separator, VARIANT * NestedTables);
  long get_WrapAroundText();
  void put_WrapAroundText(long newValue);
  float get_DistanceTop();
  void put_DistanceTop(float newValue);
  float get_DistanceBottom();
  void put_DistanceBottom(float newValue);
  float get_DistanceLeft();
  void put_DistanceLeft(float newValue);
  float get_DistanceRight();
  void put_DistanceRight(float newValue);
  float get_HorizontalPosition();
  void put_HorizontalPosition(float newValue);
  float get_VerticalPosition();
  void put_VerticalPosition(float newValue);
  long get_RelativeHorizontalPosition();
  void put_RelativeHorizontalPosition(long newValue);
  long get_RelativeVerticalPosition();
  void put_RelativeVerticalPosition(long newValue);
  long get_AllowOverlap();
  void put_AllowOverlap(long newValue);
  long get_NestingLevel();
  long get_TableDirection();
  void put_TableDirection(long newValue);
};

} // namespace MSO::Word
