#pragma once
// WTables wrapper class

#include "office/VariantableDispatch.hpp"
#include "office/MSCollection.hpp"

namespace MSO::Word {
class WApplication;
class WTable;
class WRange;

class WTables :
  public VariantableDispatch,
  public MSCollection<WTables, WTable> {
public:
  WTables() = default;
  WTables(LPDISPATCH pDispatch) : VariantableDispatch(pDispatch) {}
  WTables(const WTables& dispatchSrc) : VariantableDispatch(dispatchSrc) {}

public:
  LPUNKNOWN get_NewEnum();
  long get_Count();
  WApplication get_Application();
  long get_Creator();
  LPDISPATCH get_Parent();
  WTable get_Item(long IndexType);
  WTable AddOld(LPDISPATCH Range, long NumRows, long NumColumns);
  WTable Add(WRange Range, long NumRows, long NumColumns, VARIANT * DefaultTableBehavior, VARIANT * AutoFitBehavior);
  long get_NestingLevel();
};

} // namespace MSO::Word
